'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _babelute = require('./babelute.js');

var _lexicon = require('./lexicon/lexicon.js');

var _pragmaticsCore = require('./pragmatics/pragmatics-core.js');

var _facadePragmatics = require('./pragmatics/facade-pragmatics.js');

// import Scopes from './pragmatics/pragmatics-scopes.js';

/*
 * @author Gilles Coomans
 * @licence MIT
 * @copyright 2016 Gilles Coomans
 */

// core classes and functions
exports.default = {
	createLexicon: _lexicon.createLexicon,
	createPragmatics: _pragmaticsCore.createPragmatics,
	createFacadeInitializer: _facadePragmatics.createFacadeInitializer,
	createFacadePragmatics: _facadePragmatics.createFacadePragmatics,
	init: _lexicon.init,
	initializer: _lexicon.initializer,
	getLexicon: _lexicon.getLexicon,
	registerLexicon: _lexicon.registerLexicon,
	developOneLevel: _lexicon.developOneLevel,
	developToAtoms: _lexicon.developToAtoms,
	fromJSON: _babelute.fromJSON,
	Babelute: _babelute.Babelute,
	Lexem: _babelute.Lexem,
	Pragmatics: _pragmaticsCore.Pragmatics,
	FacadePragmatics: _facadePragmatics.FacadePragmatics
	// Scopes
};