'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.addToInitializer = exports.createInitializer = exports.Initializer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); // removed in production

var _babelute = require('../babelute.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Initializer Class
 * @protected
 */
/*
* @Author: Gilles Coomans
* @Date:   2017-03-10 13:25:25
* @Last Modified by:   Gilles Coomans
* @Last Modified time: 2017-03-10 22:31:48
*/

var Initializer = function () {
	function Initializer() {
		_classCallCheck(this, Initializer);
	}

	_createClass(Initializer, null, [{
		key: 'extends',

		/**
   * extends Initializer
   * @param  {[type]} BaseInitializer [description]
   * @return {[type]}                 [description]
   */
		value: function _extends(BaseInitializer) {

			var Class = function Class() {};
			Class.prototype = Object.create(BaseInitializer.prototype);
			Class.prototype.constructor = Class;
			return Class;
		}
	}]);

	return Initializer;
}();

/**
 * create a Initializer (based on a Babelute subclass) and instanciate it
 * @param  {Babelute} BabeluteClass   a Babelute subclass from where create initializer
 * @param  {?Initializer} BaseInitializer a parent initializer to be extended (optional)
 * @return {Initializer}               the Initializer instance
 * @protected
 */


function createInitializer(BabeluteClass) {
	var BaseInitializer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;


	var Init = BabeluteClass.Initializer = BaseInitializer ? Initializer.extends(BaseInitializer) : Initializer;
	BabeluteClass.initializer = new Init();
	BabeluteClass.initializer._empty = function () {
		return new BabeluteClass();
	};
	BabeluteClass.initializer.BabeluteClass = BabeluteClass;
	Object.keys(BabeluteClass).forEach(function (i) {
		addToInitializer(Init, i);
	});
	return BabeluteClass.initializer;
}

/**
 * add method to initializer
 * @protected
 * @param {Initializer} Initializer Initializer class where add methods in proto
 * @param {string} methodName  the name of method to add
 */
function addToInitializer(Initializer, methodName) {
	Initializer.prototype[methodName] = function () {
		return this.BabeluteClass.prototype[methodName].apply(new this.BabeluteClass(), arguments);
	};
}

exports.Initializer = Initializer;
exports.createInitializer = createInitializer;
exports.addToInitializer = addToInitializer;